<?php 
/**
 * Tabla con casillas de verificación (Resultado 2) - for_2_3b.php
 * 
 * @author    Bartolomé Sintes Marco <bartolome.sintes+mclibre@gmail.com>
 * @copyright 2010 Bartolomé Sintes Marco
 * @license   http://www.gnu.org/licenses/agpl.txt AGPL 3 or later
 * @version   2010-03-09
 * @link      http://www.mclibre.org
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

print "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?".">\n"; 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <title>Tabla con casillas de verificación 2 (Resultado 2). for (2). Ejercicios. 
  PHP. Bartolomé Sintes Marco</title>
  <link href="mclibre_php_soluciones.css" rel="stylesheet" type="text/css" 
  title="Color" />
</head>
<body>

<h1>Tabla con casillas de verificación 2 (Resultado 2)</h1>
<?php
function recoge($var)
{ 
    $tmp = (isset($_REQUEST[$var])) ? trim(strip_tags($_REQUEST[$var])) : '';
    if (get_magic_quotes_gpc()) {
        $tmp = stripslashes($tmp);
    }
    $tmp = str_replace('&', '&amp;',  $tmp);
    $tmp = str_replace('"', '&quot;', $tmp);
    return $tmp;
}

function recogeMatriz2($var) 
{
    $tmpMatriz = array();
    if (isset($_REQUEST[$var]) && is_array($_REQUEST[$var])) {
        foreach ($_REQUEST[$var] as $indice => $fila) {
            $tmp = trim(strip_tags($indice));
            if (get_magic_quotes_gpc()) {
                $tmp = stripslashes($tmp);
            }
            $tmp = str_replace('&', '&amp;',  $tmp);
            $tmp = str_replace('"', '&quot;', $tmp);
            $indiceLimpio = $tmp;
            if (is_array($fila)) {
                foreach ($fila as $indice2 => $valor) {
                    $tmp = trim(strip_tags($indice2));
                    if (get_magic_quotes_gpc()) {
                        $tmp = stripslashes($tmp);
                    }
                    $tmp = str_replace('&', '&amp;',  $tmp);
                    $tmp = str_replace('"', '&quot;', $tmp);
                    $indice2Limpio = $tmp;
        
                    $tmp = trim(strip_tags($valor));
                    if (get_magic_quotes_gpc()) {
                        $tmp = stripslashes($tmp);
                    }
                    $tmp = str_replace('&', '&amp;',  $tmp);
                    $tmp = str_replace('"', '&quot;', $tmp);
                    $valorLimpio  = $tmp;
        
                    $tmpMatriz[$indiceLimpio][$indice2Limpio] = $valorLimpio;
                }                      
            }
        }
    }
    return $tmpMatriz;
}

$numero        = recoge('numero');
$casillas      = recogeMatriz2('c');
$casillaValor  = 'on';
$numeroMinimo  = 1;
$numeroMaximo  = 20;
$numeroOk = $casillasOk = FALSE;
$casillasMarcadas = count($casillas, COUNT_RECURSIVE)-count($casillas);

if ($numero=="") {
    print "<p style=\"color: red\">No se ha recibido el tamaño de la tabla.</p>\n";
} elseif (!ctype_digit($numero)) { 
    print "<p style=\"color: red\">No se ha recibido el tamaño de la tabla "
        ."como número entero positivo.</p>\n";
} elseif (($numero<$numeroMinimo)||($numero>$numeroMaximo)) {
    print "<p style=\"color: red\">El tamaño de la tabla debe estar entre "
        ."$numeroMinimo y $numeroMaximo.</p>\n";
} else {
    $numeroOk = TRUE;
}

if ($casillasMarcadas==0) {
    print "<p>No ha marcado ninguna casilla.</p>";
} elseif ($casillasMarcadas>$numero*$numero) {
        print "<p style=\"color:red\">La matriz recibida es demasiado grande.</p>\n";
} else {
    $casillasOk = TRUE;
    foreach ($casillas as $indice => $fila) {
        if (ctype_digit((string)$indice)&&($indice<=$numero)&&is_array($fila)) {
            foreach ($fila as $indice2 => $valor2) {
                // ahora se comprueba que todos los índices son enteros inferiores al máximo
                // y que el valor es on
                if (!ctype_digit((string)$indice2)||($indice2>$numero)||($valor2!=$casillaValor)) {
                    $casillasOk = FALSE;
                }
            }
        } else {
            $casillasOk = FALSE;
        }       
    }
    if (!$casillasOk) {
        print "<p style=\"color:red\">La matriz recibida no es correcta.</p>\n";
    }    
}

if ($numeroOk && $casillasOk) {
	print "<p>Ha marcado $casillasMarcadas casilla";
	if ($casillasMarcadas>1) {
		print "s";
	}
	print " de un total de ".($numero*$numero).": ";
	foreach ($casillas as $indice => $fila) {
	    foreach ($fila as $indice2 => $valor) {
    	   print "(fila $indice columna $indice2) ";
	    }
	}
    print "</p>\n";
	print "<p><a href=\"for_2_3a.php?numero=$numero\">Volver a la tabla</a></p>\n";
}
print "<p><a href=\"for_2_3.html\">Volver al formulario inicial.</a></p>\n";
?>

<address>
  Esta página forma parte del curso "Páginas web con PHP" disponible en <a
  href="http://www.mclibre.org/">http://www.mclibre.org</a><br />
  Autor: Bartolomé Sintes Marco<br />
  Última modificación de esta página: 9 de marzo de 2010 
</address>
<p class="licencia">El programa PHP que genera esta página está bajo 
<a rel="license" href="http://www.gnu.org/licenses/agpl.txt">licencia AGPL 3 o
posterior</a>.</p>
</body>
</html>